/**
 * Autogenerated by Avro
 *
 * DO NOT EDIT DIRECTLY
 */
package com.marcofabbian.transaction.avroschema;

import org.apache.avro.generic.GenericArray;
import org.apache.avro.specific.SpecificData;
import org.apache.avro.util.Utf8;
import org.apache.avro.message.BinaryMessageEncoder;
import org.apache.avro.message.BinaryMessageDecoder;
import org.apache.avro.message.SchemaStore;

@org.apache.avro.specific.AvroGenerated
public class Isin extends org.apache.avro.specific.SpecificRecordBase implements org.apache.avro.specific.SpecificRecord {
  private static final long serialVersionUID = 5102307484722218740L;


  public static final org.apache.avro.Schema SCHEMA$ = new org.apache.avro.Schema.Parser().parse("{\"type\":\"record\",\"name\":\"Isin\",\"namespace\":\"com.marcofabbian.transaction.avroschema\",\"fields\":[{\"name\":\"id\",\"type\":\"string\",\"doc\":\"Transaction unique identifier\"},{\"name\":\"isin\",\"type\":\"string\",\"doc\":\"Isin unique identifier\"},{\"name\":\"name\",\"type\":\"string\",\"doc\":\"Isin title\"},{\"name\":\"wkn\",\"type\":\"string\",\"doc\":\"Wkn code\"},{\"name\":\"symbol\",\"type\":\"string\",\"doc\":\"Isin symbol\"},{\"name\":\"market\",\"type\":\"string\",\"doc\":\"Market segment\"}]}");
  public static org.apache.avro.Schema getClassSchema() { return SCHEMA$; }

  private static final SpecificData MODEL$ = new SpecificData();

  private static final BinaryMessageEncoder<Isin> ENCODER =
      new BinaryMessageEncoder<>(MODEL$, SCHEMA$);

  private static final BinaryMessageDecoder<Isin> DECODER =
      new BinaryMessageDecoder<>(MODEL$, SCHEMA$);

  /**
   * Return the BinaryMessageEncoder instance used by this class.
   * @return the message encoder used by this class
   */
  public static BinaryMessageEncoder<Isin> getEncoder() {
    return ENCODER;
  }

  /**
   * Return the BinaryMessageDecoder instance used by this class.
   * @return the message decoder used by this class
   */
  public static BinaryMessageDecoder<Isin> getDecoder() {
    return DECODER;
  }

  /**
   * Create a new BinaryMessageDecoder instance for this class that uses the specified {@link SchemaStore}.
   * @param resolver a {@link SchemaStore} used to find schemas by fingerprint
   * @return a BinaryMessageDecoder instance for this class backed by the given SchemaStore
   */
  public static BinaryMessageDecoder<Isin> createDecoder(SchemaStore resolver) {
    return new BinaryMessageDecoder<>(MODEL$, SCHEMA$, resolver);
  }

  /**
   * Serializes this Isin to a ByteBuffer.
   * @return a buffer holding the serialized data for this instance
   * @throws java.io.IOException if this instance could not be serialized
   */
  public java.nio.ByteBuffer toByteBuffer() throws java.io.IOException {
    return ENCODER.encode(this);
  }

  /**
   * Deserializes a Isin from a ByteBuffer.
   * @param b a byte buffer holding serialized data for an instance of this class
   * @return a Isin instance decoded from the given buffer
   * @throws java.io.IOException if the given bytes could not be deserialized into an instance of this class
   */
  public static Isin fromByteBuffer(
      java.nio.ByteBuffer b) throws java.io.IOException {
    return DECODER.decode(b);
  }

  /** Transaction unique identifier */
  private java.lang.CharSequence id;
  /** Isin unique identifier */
  private java.lang.CharSequence isin;
  /** Isin title */
  private java.lang.CharSequence name;
  /** Wkn code */
  private java.lang.CharSequence wkn;
  /** Isin symbol */
  private java.lang.CharSequence symbol;
  /** Market segment */
  private java.lang.CharSequence market;

  /**
   * Default constructor.  Note that this does not initialize fields
   * to their default values from the schema.  If that is desired then
   * one should use <code>newBuilder()</code>.
   */
  public Isin() {}

  /**
   * All-args constructor.
   * @param id Transaction unique identifier
   * @param isin Isin unique identifier
   * @param name Isin title
   * @param wkn Wkn code
   * @param symbol Isin symbol
   * @param market Market segment
   */
  public Isin(java.lang.CharSequence id, java.lang.CharSequence isin, java.lang.CharSequence name, java.lang.CharSequence wkn, java.lang.CharSequence symbol, java.lang.CharSequence market) {
    this.id = id;
    this.isin = isin;
    this.name = name;
    this.wkn = wkn;
    this.symbol = symbol;
    this.market = market;
  }

  @Override
  public org.apache.avro.specific.SpecificData getSpecificData() { return MODEL$; }

  @Override
  public org.apache.avro.Schema getSchema() { return SCHEMA$; }

  // Used by DatumWriter.  Applications should not call.
  @Override
  public java.lang.Object get(int field$) {
    switch (field$) {
    case 0: return id;
    case 1: return isin;
    case 2: return name;
    case 3: return wkn;
    case 4: return symbol;
    case 5: return market;
    default: throw new IndexOutOfBoundsException("Invalid index: " + field$);
    }
  }

  // Used by DatumReader.  Applications should not call.
  @Override
  @SuppressWarnings(value="unchecked")
  public void put(int field$, java.lang.Object value$) {
    switch (field$) {
    case 0: id = (java.lang.CharSequence)value$; break;
    case 1: isin = (java.lang.CharSequence)value$; break;
    case 2: name = (java.lang.CharSequence)value$; break;
    case 3: wkn = (java.lang.CharSequence)value$; break;
    case 4: symbol = (java.lang.CharSequence)value$; break;
    case 5: market = (java.lang.CharSequence)value$; break;
    default: throw new IndexOutOfBoundsException("Invalid index: " + field$);
    }
  }

  /**
   * Gets the value of the 'id' field.
   * @return Transaction unique identifier
   */
  public java.lang.CharSequence getId() {
    return id;
  }


  /**
   * Sets the value of the 'id' field.
   * Transaction unique identifier
   * @param value the value to set.
   */
  public void setId(java.lang.CharSequence value) {
    this.id = value;
  }

  /**
   * Gets the value of the 'isin' field.
   * @return Isin unique identifier
   */
  public java.lang.CharSequence getIsin() {
    return isin;
  }


  /**
   * Sets the value of the 'isin' field.
   * Isin unique identifier
   * @param value the value to set.
   */
  public void setIsin(java.lang.CharSequence value) {
    this.isin = value;
  }

  /**
   * Gets the value of the 'name' field.
   * @return Isin title
   */
  public java.lang.CharSequence getName() {
    return name;
  }


  /**
   * Sets the value of the 'name' field.
   * Isin title
   * @param value the value to set.
   */
  public void setName(java.lang.CharSequence value) {
    this.name = value;
  }

  /**
   * Gets the value of the 'wkn' field.
   * @return Wkn code
   */
  public java.lang.CharSequence getWkn() {
    return wkn;
  }


  /**
   * Sets the value of the 'wkn' field.
   * Wkn code
   * @param value the value to set.
   */
  public void setWkn(java.lang.CharSequence value) {
    this.wkn = value;
  }

  /**
   * Gets the value of the 'symbol' field.
   * @return Isin symbol
   */
  public java.lang.CharSequence getSymbol() {
    return symbol;
  }


  /**
   * Sets the value of the 'symbol' field.
   * Isin symbol
   * @param value the value to set.
   */
  public void setSymbol(java.lang.CharSequence value) {
    this.symbol = value;
  }

  /**
   * Gets the value of the 'market' field.
   * @return Market segment
   */
  public java.lang.CharSequence getMarket() {
    return market;
  }


  /**
   * Sets the value of the 'market' field.
   * Market segment
   * @param value the value to set.
   */
  public void setMarket(java.lang.CharSequence value) {
    this.market = value;
  }

  /**
   * Creates a new Isin RecordBuilder.
   * @return A new Isin RecordBuilder
   */
  public static com.marcofabbian.transaction.avroschema.Isin.Builder newBuilder() {
    return new com.marcofabbian.transaction.avroschema.Isin.Builder();
  }

  /**
   * Creates a new Isin RecordBuilder by copying an existing Builder.
   * @param other The existing builder to copy.
   * @return A new Isin RecordBuilder
   */
  public static com.marcofabbian.transaction.avroschema.Isin.Builder newBuilder(com.marcofabbian.transaction.avroschema.Isin.Builder other) {
    if (other == null) {
      return new com.marcofabbian.transaction.avroschema.Isin.Builder();
    } else {
      return new com.marcofabbian.transaction.avroschema.Isin.Builder(other);
    }
  }

  /**
   * Creates a new Isin RecordBuilder by copying an existing Isin instance.
   * @param other The existing instance to copy.
   * @return A new Isin RecordBuilder
   */
  public static com.marcofabbian.transaction.avroschema.Isin.Builder newBuilder(com.marcofabbian.transaction.avroschema.Isin other) {
    if (other == null) {
      return new com.marcofabbian.transaction.avroschema.Isin.Builder();
    } else {
      return new com.marcofabbian.transaction.avroschema.Isin.Builder(other);
    }
  }

  /**
   * RecordBuilder for Isin instances.
   */
  @org.apache.avro.specific.AvroGenerated
  public static class Builder extends org.apache.avro.specific.SpecificRecordBuilderBase<Isin>
    implements org.apache.avro.data.RecordBuilder<Isin> {

    /** Transaction unique identifier */
    private java.lang.CharSequence id;
    /** Isin unique identifier */
    private java.lang.CharSequence isin;
    /** Isin title */
    private java.lang.CharSequence name;
    /** Wkn code */
    private java.lang.CharSequence wkn;
    /** Isin symbol */
    private java.lang.CharSequence symbol;
    /** Market segment */
    private java.lang.CharSequence market;

    /** Creates a new Builder */
    private Builder() {
      super(SCHEMA$, MODEL$);
    }

    /**
     * Creates a Builder by copying an existing Builder.
     * @param other The existing Builder to copy.
     */
    private Builder(com.marcofabbian.transaction.avroschema.Isin.Builder other) {
      super(other);
      if (isValidValue(fields()[0], other.id)) {
        this.id = data().deepCopy(fields()[0].schema(), other.id);
        fieldSetFlags()[0] = other.fieldSetFlags()[0];
      }
      if (isValidValue(fields()[1], other.isin)) {
        this.isin = data().deepCopy(fields()[1].schema(), other.isin);
        fieldSetFlags()[1] = other.fieldSetFlags()[1];
      }
      if (isValidValue(fields()[2], other.name)) {
        this.name = data().deepCopy(fields()[2].schema(), other.name);
        fieldSetFlags()[2] = other.fieldSetFlags()[2];
      }
      if (isValidValue(fields()[3], other.wkn)) {
        this.wkn = data().deepCopy(fields()[3].schema(), other.wkn);
        fieldSetFlags()[3] = other.fieldSetFlags()[3];
      }
      if (isValidValue(fields()[4], other.symbol)) {
        this.symbol = data().deepCopy(fields()[4].schema(), other.symbol);
        fieldSetFlags()[4] = other.fieldSetFlags()[4];
      }
      if (isValidValue(fields()[5], other.market)) {
        this.market = data().deepCopy(fields()[5].schema(), other.market);
        fieldSetFlags()[5] = other.fieldSetFlags()[5];
      }
    }

    /**
     * Creates a Builder by copying an existing Isin instance
     * @param other The existing instance to copy.
     */
    private Builder(com.marcofabbian.transaction.avroschema.Isin other) {
      super(SCHEMA$, MODEL$);
      if (isValidValue(fields()[0], other.id)) {
        this.id = data().deepCopy(fields()[0].schema(), other.id);
        fieldSetFlags()[0] = true;
      }
      if (isValidValue(fields()[1], other.isin)) {
        this.isin = data().deepCopy(fields()[1].schema(), other.isin);
        fieldSetFlags()[1] = true;
      }
      if (isValidValue(fields()[2], other.name)) {
        this.name = data().deepCopy(fields()[2].schema(), other.name);
        fieldSetFlags()[2] = true;
      }
      if (isValidValue(fields()[3], other.wkn)) {
        this.wkn = data().deepCopy(fields()[3].schema(), other.wkn);
        fieldSetFlags()[3] = true;
      }
      if (isValidValue(fields()[4], other.symbol)) {
        this.symbol = data().deepCopy(fields()[4].schema(), other.symbol);
        fieldSetFlags()[4] = true;
      }
      if (isValidValue(fields()[5], other.market)) {
        this.market = data().deepCopy(fields()[5].schema(), other.market);
        fieldSetFlags()[5] = true;
      }
    }

    /**
      * Gets the value of the 'id' field.
      * Transaction unique identifier
      * @return The value.
      */
    public java.lang.CharSequence getId() {
      return id;
    }


    /**
      * Sets the value of the 'id' field.
      * Transaction unique identifier
      * @param value The value of 'id'.
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Isin.Builder setId(java.lang.CharSequence value) {
      validate(fields()[0], value);
      this.id = value;
      fieldSetFlags()[0] = true;
      return this;
    }

    /**
      * Checks whether the 'id' field has been set.
      * Transaction unique identifier
      * @return True if the 'id' field has been set, false otherwise.
      */
    public boolean hasId() {
      return fieldSetFlags()[0];
    }


    /**
      * Clears the value of the 'id' field.
      * Transaction unique identifier
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Isin.Builder clearId() {
      id = null;
      fieldSetFlags()[0] = false;
      return this;
    }

    /**
      * Gets the value of the 'isin' field.
      * Isin unique identifier
      * @return The value.
      */
    public java.lang.CharSequence getIsin() {
      return isin;
    }


    /**
      * Sets the value of the 'isin' field.
      * Isin unique identifier
      * @param value The value of 'isin'.
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Isin.Builder setIsin(java.lang.CharSequence value) {
      validate(fields()[1], value);
      this.isin = value;
      fieldSetFlags()[1] = true;
      return this;
    }

    /**
      * Checks whether the 'isin' field has been set.
      * Isin unique identifier
      * @return True if the 'isin' field has been set, false otherwise.
      */
    public boolean hasIsin() {
      return fieldSetFlags()[1];
    }


    /**
      * Clears the value of the 'isin' field.
      * Isin unique identifier
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Isin.Builder clearIsin() {
      isin = null;
      fieldSetFlags()[1] = false;
      return this;
    }

    /**
      * Gets the value of the 'name' field.
      * Isin title
      * @return The value.
      */
    public java.lang.CharSequence getName() {
      return name;
    }


    /**
      * Sets the value of the 'name' field.
      * Isin title
      * @param value The value of 'name'.
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Isin.Builder setName(java.lang.CharSequence value) {
      validate(fields()[2], value);
      this.name = value;
      fieldSetFlags()[2] = true;
      return this;
    }

    /**
      * Checks whether the 'name' field has been set.
      * Isin title
      * @return True if the 'name' field has been set, false otherwise.
      */
    public boolean hasName() {
      return fieldSetFlags()[2];
    }


    /**
      * Clears the value of the 'name' field.
      * Isin title
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Isin.Builder clearName() {
      name = null;
      fieldSetFlags()[2] = false;
      return this;
    }

    /**
      * Gets the value of the 'wkn' field.
      * Wkn code
      * @return The value.
      */
    public java.lang.CharSequence getWkn() {
      return wkn;
    }


    /**
      * Sets the value of the 'wkn' field.
      * Wkn code
      * @param value The value of 'wkn'.
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Isin.Builder setWkn(java.lang.CharSequence value) {
      validate(fields()[3], value);
      this.wkn = value;
      fieldSetFlags()[3] = true;
      return this;
    }

    /**
      * Checks whether the 'wkn' field has been set.
      * Wkn code
      * @return True if the 'wkn' field has been set, false otherwise.
      */
    public boolean hasWkn() {
      return fieldSetFlags()[3];
    }


    /**
      * Clears the value of the 'wkn' field.
      * Wkn code
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Isin.Builder clearWkn() {
      wkn = null;
      fieldSetFlags()[3] = false;
      return this;
    }

    /**
      * Gets the value of the 'symbol' field.
      * Isin symbol
      * @return The value.
      */
    public java.lang.CharSequence getSymbol() {
      return symbol;
    }


    /**
      * Sets the value of the 'symbol' field.
      * Isin symbol
      * @param value The value of 'symbol'.
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Isin.Builder setSymbol(java.lang.CharSequence value) {
      validate(fields()[4], value);
      this.symbol = value;
      fieldSetFlags()[4] = true;
      return this;
    }

    /**
      * Checks whether the 'symbol' field has been set.
      * Isin symbol
      * @return True if the 'symbol' field has been set, false otherwise.
      */
    public boolean hasSymbol() {
      return fieldSetFlags()[4];
    }


    /**
      * Clears the value of the 'symbol' field.
      * Isin symbol
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Isin.Builder clearSymbol() {
      symbol = null;
      fieldSetFlags()[4] = false;
      return this;
    }

    /**
      * Gets the value of the 'market' field.
      * Market segment
      * @return The value.
      */
    public java.lang.CharSequence getMarket() {
      return market;
    }


    /**
      * Sets the value of the 'market' field.
      * Market segment
      * @param value The value of 'market'.
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Isin.Builder setMarket(java.lang.CharSequence value) {
      validate(fields()[5], value);
      this.market = value;
      fieldSetFlags()[5] = true;
      return this;
    }

    /**
      * Checks whether the 'market' field has been set.
      * Market segment
      * @return True if the 'market' field has been set, false otherwise.
      */
    public boolean hasMarket() {
      return fieldSetFlags()[5];
    }


    /**
      * Clears the value of the 'market' field.
      * Market segment
      * @return This builder.
      */
    public com.marcofabbian.transaction.avroschema.Isin.Builder clearMarket() {
      market = null;
      fieldSetFlags()[5] = false;
      return this;
    }

    @Override
    @SuppressWarnings("unchecked")
    public Isin build() {
      try {
        Isin record = new Isin();
        record.id = fieldSetFlags()[0] ? this.id : (java.lang.CharSequence) defaultValue(fields()[0]);
        record.isin = fieldSetFlags()[1] ? this.isin : (java.lang.CharSequence) defaultValue(fields()[1]);
        record.name = fieldSetFlags()[2] ? this.name : (java.lang.CharSequence) defaultValue(fields()[2]);
        record.wkn = fieldSetFlags()[3] ? this.wkn : (java.lang.CharSequence) defaultValue(fields()[3]);
        record.symbol = fieldSetFlags()[4] ? this.symbol : (java.lang.CharSequence) defaultValue(fields()[4]);
        record.market = fieldSetFlags()[5] ? this.market : (java.lang.CharSequence) defaultValue(fields()[5]);
        return record;
      } catch (org.apache.avro.AvroMissingFieldException e) {
        throw e;
      } catch (java.lang.Exception e) {
        throw new org.apache.avro.AvroRuntimeException(e);
      }
    }
  }

  @SuppressWarnings("unchecked")
  private static final org.apache.avro.io.DatumWriter<Isin>
    WRITER$ = (org.apache.avro.io.DatumWriter<Isin>)MODEL$.createDatumWriter(SCHEMA$);

  @Override public void writeExternal(java.io.ObjectOutput out)
    throws java.io.IOException {
    WRITER$.write(this, SpecificData.getEncoder(out));
  }

  @SuppressWarnings("unchecked")
  private static final org.apache.avro.io.DatumReader<Isin>
    READER$ = (org.apache.avro.io.DatumReader<Isin>)MODEL$.createDatumReader(SCHEMA$);

  @Override public void readExternal(java.io.ObjectInput in)
    throws java.io.IOException {
    READER$.read(this, SpecificData.getDecoder(in));
  }

  @Override protected boolean hasCustomCoders() { return true; }

  @Override public void customEncode(org.apache.avro.io.Encoder out)
    throws java.io.IOException
  {
    out.writeString(this.id);

    out.writeString(this.isin);

    out.writeString(this.name);

    out.writeString(this.wkn);

    out.writeString(this.symbol);

    out.writeString(this.market);

  }

  @Override public void customDecode(org.apache.avro.io.ResolvingDecoder in)
    throws java.io.IOException
  {
    org.apache.avro.Schema.Field[] fieldOrder = in.readFieldOrderIfDiff();
    if (fieldOrder == null) {
      this.id = in.readString(this.id instanceof Utf8 ? (Utf8)this.id : null);

      this.isin = in.readString(this.isin instanceof Utf8 ? (Utf8)this.isin : null);

      this.name = in.readString(this.name instanceof Utf8 ? (Utf8)this.name : null);

      this.wkn = in.readString(this.wkn instanceof Utf8 ? (Utf8)this.wkn : null);

      this.symbol = in.readString(this.symbol instanceof Utf8 ? (Utf8)this.symbol : null);

      this.market = in.readString(this.market instanceof Utf8 ? (Utf8)this.market : null);

    } else {
      for (int i = 0; i < 6; i++) {
        switch (fieldOrder[i].pos()) {
        case 0:
          this.id = in.readString(this.id instanceof Utf8 ? (Utf8)this.id : null);
          break;

        case 1:
          this.isin = in.readString(this.isin instanceof Utf8 ? (Utf8)this.isin : null);
          break;

        case 2:
          this.name = in.readString(this.name instanceof Utf8 ? (Utf8)this.name : null);
          break;

        case 3:
          this.wkn = in.readString(this.wkn instanceof Utf8 ? (Utf8)this.wkn : null);
          break;

        case 4:
          this.symbol = in.readString(this.symbol instanceof Utf8 ? (Utf8)this.symbol : null);
          break;

        case 5:
          this.market = in.readString(this.market instanceof Utf8 ? (Utf8)this.market : null);
          break;

        default:
          throw new java.io.IOException("Corrupt ResolvingDecoder.");
        }
      }
    }
  }
}










